CIPDataTracker
Date: 2019-10-22

org.jmol.symmetry

## Class CIPDataTracker

- java.lang.Object
- - org.jmol.symmetry.CIPData
  - - org.jmol.symmetry.CIPDataTracker

-     public class CIPDataTracker
      extends CIPData

  An optional class to track digraph paths to decisions. Used in Jmol to create the auxiliary structure _M.CIPInfo.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `(package private) class` | `CIPDataTracker.CIPTracker`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `java.util.Map<java.lang.String,CIPDataTracker.CIPTracker>` | `htTracker` a table to track decision making when only one atom is selected for calculation
    `private int` | `lastIndex`
    `private java.util.Map<java.lang.String,java.lang.Object>` | `lastInfo`

    - ### Fields inherited from class org.jmol.symmetry.CIPData

      `atoms, bsAromatic, bsAtoms, bsAtropisomeric, bsAzacyclic, bsEnes, bsHelixM, bsHelixP, bsKekuleAmbiguous, bsMolecule, bsNegativeAromatic, bsXAromatic, lstSmallRings, testRule6Full, TRIGONALITY_MIN, vNorm, vTemp, vwr`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CIPDataTracker()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `private java.util.Map<java.lang.String,java.lang.Object>` | `getModelAuxiliaryInfoForAtom(int index)`
    `(package private) java.lang.String` | `getRootTrackerResult(CIPChirality.CIPAtom root)` CIPDataTracker only
    `private static java.lang.String` | `getTrackerKey(CIPChirality.CIPAtom root, CIPChirality.CIPAtom a, CIPChirality.CIPAtom b)`
    `protected boolean` | `isTracker()` Subclass identifier
    `private void` | `setCIPInfo(java.lang.String s, int index, java.lang.String name)`
    `(package private) void` | `track(CIPChirality cip, CIPChirality.CIPAtom a, CIPChirality.CIPAtom b, int sphere, int finalScore, boolean trackTerminal)` Track this decision - CIPDataTracker only

    - ### Methods inherited from class org.jmol.symmetry.CIPData

      `checkHandedness, couldBeChiralAlkene, couldBeChiralAtom, getBondOrder, getEneKekule, getList, getTrigonality, init, isCis, isPositiveTorsion, isSmiles, match, set, setCoord, setRule6Full`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### htTracker

          public java.util.Map<java.lang.String,CIPDataTracker.CIPTracker> htTracker

      a table to track decision making when only one atom is selected for calculation

    - #### lastIndex

          private int lastIndex

    - #### lastInfo

          private java.util.Map<java.lang.String,java.lang.Object> lastInfo

  - ### Constructor Detail

    - #### CIPDataTracker

          public CIPDataTracker()

  - ### Method Detail

    - #### isTracker

          protected boolean isTracker()

      Description copied from class: `CIPData`
      Subclass identifier
      Overrides:
        `isTracker` in class `CIPData`
      Returns:
        true for CIPDataTracker

    - #### track

          void track(CIPChirality cip,
                     CIPChirality.CIPAtom a,
                     CIPChirality.CIPAtom b,
                     int sphere,
                     int finalScore,
                     boolean trackTerminal)

      Description copied from class: `CIPData`
      Track this decision - CIPDataTracker only
      Overrides:
        `track` in class `CIPData`

    - #### getRootTrackerResult

          java.lang.String getRootTrackerResult(CIPChirality.CIPAtom root)

      Description copied from class: `CIPData`
      CIPDataTracker only
      Overrides:
        `getRootTrackerResult` in class `CIPData`
      Returns:
        string expression of decision path

    - #### setCIPInfo

          private void setCIPInfo(java.lang.String s,
                                  int index,
                                  java.lang.String name)

    - #### getModelAuxiliaryInfoForAtom

          private java.util.Map<java.lang.String,java.lang.Object> getModelAuxiliaryInfoForAtom(int index)

    - #### getTrackerKey

          private static java.lang.String getTrackerKey(CIPChirality.CIPAtom root,
                                                        CIPChirality.CIPAtom a,
                                                        CIPChirality.CIPAtom b)